VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CIniFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'''''''''''''''''''''''''''''
'
' CIniFile
' Ȩ 2009-2017 ZX Inc.
' 汾 1.3.10
'
' : ȡINIļ(Unicode/ANSI)
'
' : scrrun.dll, mFSO
'
'''''''''''''''''''''''''''''
Option Explicit

Private strINI As String
Private bAutoCreate As Boolean
Private lBufSize As Long
Private UseUnicode As Boolean

Private Declare Function GetPrivateProfileSectionA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileSectionW Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpReturnedString As Long, ByVal nSize As Long, ByVal lpFileName As Long) As Long
Private Declare Function GetPrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpDefault As String, ByVal lpReturnedString As String, ByVal nSize As Long, ByVal lpFileName As String) As Long
Private Declare Function GetPrivateProfileStringW Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpKeyName As Long, ByVal lpDefault As Long, ByVal lpReturnedString As Long, ByVal nSize As Long, ByVal lpFileName As Long) As Long
Private Declare Function WritePrivateProfileStringA Lib "kernel32" (ByVal lpApplicationName As String, ByVal lpKeyName As String, ByVal lpString As String, ByVal lpFileName As String) As Long
Private Declare Function WritePrivateProfileStringW Lib "kernel32" (ByVal lpApplicationName As Long, ByVal lpKeyName As Long, ByVal lpString As Long, ByVal lpFileName As Long) As Long

Public Property Let AutoCreate(AutoCreateIni As Boolean)
bAutoCreate = AutoCreateIni
End Property

Public Property Get BufferSize() As Long
BufferSize = lBufSize
End Property

Public Property Let BufferSize(Size As Long)
If Size < 0 Then Err.Raise 5 Else lBufSize = Size
End Property

Public Property Get IniFileName() As String
'' Returns the current ini path
IniFileName = strINI
End Property

Public Property Let IniFileName(ByVal NewIniPath As String)
'' Sets the new ini path
strINI = NewIniPath
If Not FileExists(strINI) And bAutoCreate Then CreateIniFile strINI
End Property

Public Property Let Unicode(ByVal U As Boolean)
IniFileName = ""
UseUnicode = U
End Property

Public Sub CreateIniFile(strPath As String)
'' Make a new ini file
strINI = strPath
CreateNewFile strINI, False, True
End Sub

''***************************************KeyWord""(Sub)********
Public Function DelIniKey(ByVal SectionName As String, ByVal KeyWord As String)
Dim RetVal As Integer
If UseUnicode Then
    RetVal = WritePrivateProfileStringW(StrPtr(SectionName), StrPtr(KeyWord), 0&, StrPtr(strINI))
Else
    RetVal = WritePrivateProfileStringA(SectionName, KeyWord, vbNullString, strINI)
End If
End Function

''sectionдһKeyһ""
''************************************** Section""(Sub)********
Public Function DelIniSec(ByVal SectionName As String) ''section
Dim RetVal As Integer
If UseUnicode Then
    RetVal = WritePrivateProfileStringW(StrPtr(SectionName), 0&, 0&, StrPtr(strINI))
Else
    RetVal = WritePrivateProfileStringA(SectionName, vbNullString, vbNullString, strINI)
End If
End Function

Public Function GetIniKey(strSection As String, strKey As String, Optional strDefault As String = vbNullString) As String
Dim strTmp As String
Dim lngRet As Long, BufSize As Long

BufSize = Len(strDefault)
If BufSize < lBufSize Then BufSize = lBufSize
strTmp = Space$(BufSize)
If UseUnicode Then
    lngRet = GetPrivateProfileStringW(StrPtr(strSection), StrPtr(strKey), StrPtr(strDefault), StrPtr(strTmp), BufSize, StrPtr(strINI))
    GetIniKey = Left$(strTmp, lngRet)
Else
    lngRet = GetPrivateProfileStringA(strSection, strKey, strDefault, strTmp, BufSize, strINI)
    GetIniKey = Left$(strTmp, InStr(strTmp, vbNullChar) - 1)
End If
End Function

Public Function GetIniSec(strSection As String) As Dictionary
Dim strTmp As String
Dim lngRet As Long, BufSize As Long

BufSize = lBufSize
strTmp = Space$(BufSize)
If UseUnicode Then
    lngRet = GetPrivateProfileSectionW(StrPtr(strSection), StrPtr(strTmp), BufSize, StrPtr(strINI))
    strTmp = Left$(strTmp, lngRet)
Else
    lngRet = GetPrivateProfileSectionA(strSection, strTmp, BufSize, strINI)
    strTmp = Left$(strTmp, InStr(strTmp, vbNullChar & vbNullChar) - 1)
End If
Dim Sec$(), i&, p&, Key$, Value$, d As New Dictionary
Sec = Split(strTmp, vbNullChar)
For i = 0 To UBound(Sec)
    p = InStr(Sec(i), "=")
    If p <> 0 Then
        Key = Trim$(Left$(Sec(i), p - 1))
        Value = Trim$(Mid$(Sec(i), p + 1))
        If Key <> "" Then
            If d.Exists(Key) Then
                d(Key) = Value
            Else
                d.Add Key, Value
            End If
        End If
    Else
        Key = Trim$(Sec(i))
        d.Add Key, ""
    End If
Next i
Set GetIniSec = d
End Function

Public Sub WriteIniKey(strSection As String, strKey As String, strValue As String)
'' Write to strINI
If UseUnicode Then
    WritePrivateProfileStringW StrPtr(strSection), StrPtr(strKey), StrPtr(strValue), StrPtr(strINI)
Else
    WritePrivateProfileStringA strSection, strKey, strValue, strINI
End If
End Sub

Private Sub Class_Initialize()
UseUnicode = True
lBufSize = 65500
bAutoCreate = True
End Sub

